import processing.core.*; 
import processing.xml.*; 

import processing.opengl.*; 
import javax.media.opengl.*; 
import controlP5.*; 
import javax.swing.*; 
import SpringGUI.*; 
import unlekker.data.*; 
import toxi.geom.*; 
import toxi.geom.mesh.*; 
import toxi.geom.mesh.subdiv.*; 
import toxi.processing.*; 
import toxi.util.*; 
import toxi.volume.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class A01_Binary_to_Voxels extends PApplet {


// Digital Material Cube 001
// FabLab Japan
// Hiroya Tanaka

// Import

  




SpringGUI gui; 

// File IO
String getFile; 
String setFile;
String [] txtarray = null;
String txt = null;
boolean saveSTL = false;

// Import Mesh Library 






ToxiclibsSupport gfx;

 
// Field 
int FIELD_SIZE = 50;
int FIELD_STEP = 10;

// Camera 
float expo = 1;
float rotx, roty;
float rate = 0.01f;

// Resolution of Box
int resolution = 16;

// ControlP5
ControlP5 controlP5;
Textfield tfUserName;       // \u30c6\u30ad\u30b9\u30c8\u30d5\u30a3\u30fc\u30eb\u30c9
String txts = "";

// Text
PFont  font;  
long   time;  



public void setup() {
 
  size(640, 480, OPENGL);    
  
  // Control Panel 
  controlP5 = new ControlP5(this);  
  tfUserName = controlP5.addTextfield("textfield", 10, 65, 200, 20);
  tfUserName.setFocus(true);
  controlP5.addSlider("resolution",1,48,10,40,200,20);
  controlP5.addButton("savefile",10,10,450,80,19);

}


public void draw() {

  background(0);
  PGraphicsOpenGL pgl = (PGraphicsOpenGL)g;  
   
  // Lighting
    ambientLight(150, 150, 150);
    directionalLight(255,255,255,-1,0,0);
    pointLight(160, 160, 160, mouseX, mouseY, 200);
    spotLight(100, 100, 100, mouseX, mouseY, 200, 0, 0, -1, PI, 2);
    
    
  // Camera
  if (getFile == null && setFile == null) {
     if (mousePressed == true){
  rotx = rotx + (mouseY - pmouseY) * rate;
  roty = roty + (mouseX - pmouseX) * rate; 
     }
  } else { 
  rotx = 0;
  roty = 0;
  expo = 1;
  }
  
  //Text
  font = createFont("Meiryo", 12);
  textFont(font);
  fill(255,255,255);
  text("01 Binary Code to Voxels", 10, 25); 
  
  // Zoom In and Out
  if (keyPressed && keyCode==UP) { expo = expo + 0.01f; }
  if (keyPressed && keyCode==DOWN) { expo = expo - 0.01f; }

  // \u30d5\u30ec\u30fc\u30e0\u306e\u63cf\u753b
  pushStyle();
  translate(320,240,200);
  rotateX(rotx); rotateY(roty);scale(expo);
  
  stroke(255, 255, 255);  
  FIELD_STEP = FIELD_SIZE*2/resolution;
  
  for(int k = 1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          // x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          // y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          // z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
        pushMatrix(); 
        translate(realx,realy,realz);
        noFill();
        box(FIELD_STEP ,FIELD_STEP ,FIELD_STEP );
        popMatrix();
       }
    }
  }

  popStyle();
  
  // \u30dc\u30af\u30bb\u30eb\u306e\u63cf\u753b
  
  // STL\u66f8\u304d\u51fa\u3057
    if(setFile != null){
   beginRaw("unlekker.data.STL",setFile+".stl");
   println("start :"+setFile);
  }
  
  pushStyle();
  noStroke();
  noFill();
  int len = txts.length(); 
  int l = 0;
  
  FIELD_STEP = FIELD_SIZE*2/resolution;

  for(int k = 1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          //x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
         pushMatrix();
         translate(realx,realy,realz); 
         if (len >0) {
         if (txts.charAt(l)=='1') {  fill(200,200,200); box(FIELD_STEP,FIELD_STEP,FIELD_STEP); } 
         l=l+1; 
         if (l > len-1) { l = 0; }
         }
         
         popMatrix();
       }
    }
  }
  popStyle();
  
 // STL\u66f8\u304d\u51fa\u3057\u7d42\u4e86
  if(setFile !=null) {
  endRaw();   
 setFile = null;
   println("end");
  }
  
  // \u03b1\u5408\u6210\u3092\u6709\u52b9\u306b\u3059\u308b
  GL gl = pgl.beginGL();
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  gl.glDisable(GL.GL_DEPTH_TEST);
  pgl.endGL();
  

  // GUI \u30b3\u30f3\u30dd\u30fc\u30cd\u30f3\u30c8\u63cf\u753b\u306e\u305f\u3081\u306e\u8a2d\u5b9a
  camera();
  gl = pgl.beginGL();
  gl.glDisable(GL.GL_DEPTH_TEST);  // \u6df1\u5ea6\u30c6\u30b9\u30c8\u3092\u7121\u52b9\u5316
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  pgl.endGL();
  

}


// \u30c6\u30ad\u30b9\u30c8\u304c\u5165\u529b\u3055\u308c\u305f\u969b\u306b\u30b3\u30fc\u30eb\u30d0\u30c3\u30af\u3055\u308c\u308b\u30e1\u30bd\u30c3\u30c9
public synchronized void textfield(String txt) {
    txts = txt; 
}

// Save\u30dc\u30bf\u30f3
public void savefile(int theValue) {
     setFile = setFileName();
}



//\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3001\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97\u306e\u51e6\u7406 
public String getFileName(){
  //\u51e6\u7406\u30bf\u30a4\u30df\u30f3\u30b0\u306e\u8a2d\u5b9a 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
 try {
   //\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u8868\u793a 
   JFileChooser fc = new JFileChooser(); 
   int returnVal = fc.showOpenDialog(null);
   //\u300c\u958b\u304f\u300d\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u5834\u5408
   if (returnVal == JFileChooser.APPROVE_OPTION) {
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97 
     File file = fc.getSelectedFile();
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u306e\u30d1\u30b9\u53d6\u5f97 
     getFile = file.getPath(); 
   } 
 }
 //\u4e0a\u8a18\u4ee5\u5916\u306e\u5834\u5408 
 catch (Exception e) {
   //\u30a8\u30e9\u30fc\u51fa\u529b 
   e.printStackTrace(); 
 } 
    } 
  } 
  );
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97
  return getFile; 
}


//\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u3001\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97\u306e\u51e6\u7406 
public String setFileName(){
  //\u51e6\u7406\u30bf\u30a4\u30df\u30f3\u30b0\u306e\u8a2d\u5b9a 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
 try {
   //\u30d5\u30a1\u30a4\u30eb\u9078\u629e\u753b\u9762\u8868\u793a 
   JFileChooser fc = new JFileChooser(); 
   int returnVal = fc.showSaveDialog(null);
   //\u300c\u958b\u304f\u300d\u30dc\u30bf\u30f3\u304c\u62bc\u3055\u308c\u305f\u5834\u5408
   if (returnVal == JFileChooser.APPROVE_OPTION) {
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u53d6\u5f97 
     File file = fc.getSelectedFile();
     //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u306e\u30d1\u30b9\u53d6\u5f97 
     setFile = file.getPath(); 
   } 
 }
 //\u4e0a\u8a18\u4ee5\u5916\u306e\u5834\u5408 
 catch (Exception e) {
   //\u30a8\u30e9\u30fc\u51fa\u529b 
   e.printStackTrace(); 
 } 
    } 
  } 
  );
  //\u9078\u629e\u30d5\u30a1\u30a4\u30eb\u30d1\u30b9\u53d6\u5f97
  return setFile; 
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "A01_Binary_to_Voxels" });
  }
}
